/*
 * $Id: EchoServlet.java,v 1.5 2003/06/22 12:32:15 fukuda Exp $
 */
package com.oki.sip.tutorial;

import java.io.IOException;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.sip.ServletParseException;
import javax.servlet.sip.Address;
import javax.servlet.sip.SipURI;
import javax.servlet.sip.SipApplicationSession;
import javax.servlet.sip.SipServlet;
import javax.servlet.sip.SipServletRequest;
import javax.servlet.sip.SipServletResponse;
import javax.servlet.sip.SipSession;
import com.oki.sip.equips.signal.BasicSipServlet;

/**
 */
public class EchoServlet extends BasicSipServlet {

    public void init() throws ServletException {
	super.init();
    }

    protected void doMessage(SipServletRequest req)
        throws ServletException, IOException
    {
	if(req.getContentLength() == 0) {
	    initChat(req);
	    return;
	}

	// ꥯȤåܥǥ
	String msg = (String) req.getContent();

	// åܥǥԾ(msender)ȥåʸ(mbody)ʬΥ롣
	String msender = null;
	String mbody = null;
	int index = msg.indexOf("\r\n");
	if(index > 0) {
	    msender = msg.substring(0, index);
	    mbody = msg.substring(index + 2);
	    if(mbody.endsWith(":"))
		mbody = mbody.substring(0, mbody.length() - 1);
	} else {
	    msender = msg.trim();
	    mbody = null;
	}
	
	if(mbody == null) {
	    terminateChat(req);
	} else {
	    sendChat(req, mbody);
	}
    }

    /**
     * ˥åȥåΩ᥽åɡ
     */
    private void initChat(SipServletRequest req)
	throws IOException, ServletException
    {
	SipServletResponse res = createResponse(req, 302);

	res.setAddressHeader("Contact", getLocalContact(req));
	res.send();
	invalidateAppSession(res);
    }

    /**
     * åȥå˥å᥽åɡ
     */
    private void sendChat(SipServletRequest req, String mbody)
	throws IOException, ServletException
    {
	// åΥå
	Address remote = req.getFrom();
	Address local = req.getTo();
	String chatID = req.getHeader("X-Chat-Id");

	// 200 ֿ
	SipServletResponse res = createResponse(req, 200);
	res.send();
	invalidateAppSession(res);

	// åʸ
	String emsg = local.getURI().toString() + "\r\n" + mbody.toUpperCase() + ":";

	// Υ󥿥Ⱦ
	SipURI remoteURI = (SipURI) remote.getURI();
	Address contact = (Address) getLocation().getContacts(remoteURI, null).get(0);

	// SIPꥯȤ
	SipApplicationSession appSession = getSipFactory().createApplicationSession();
	SipServletRequest req2 = initiateRequest(appSession,
						 "MESSAGE",
						 local,
						 remote);
	req2.setContent(emsg, "text/plain; charset=UTF-8");
	req2.setHeader("X-Chat-Id", chatID);
	req2.setRequestURI((SipURI) contact.getURI());

	// SIPꥯȤ
	req2.send();
    }

    /**
     * åȥå˴᥽åɡ
     * 200 Ǳ롣
     */
    private void terminateChat(SipServletRequest req)
	throws IOException
    {
	SipServletResponse res = createResponse(req, 200);
	res.send();
	invalidateAppSession(res);
    }

    /**
     * SIP֥åȤMESSAGEФ᥽åɡ
     */
    protected void doResponse(SipServletResponse res)
	throws IOException, ServletException
    {
	if(res.getStatus() >= 200)
	    invalidateAppSession(res);
    }


    /**
     * SipServletRequest 鼫ʬȤ򥳥󥿥Ⱦ᥽åɡ
     */
    private Address getLocalContact(SipServletRequest req)
	throws ServletParseException
    {
	StringBuffer sb = new StringBuffer();
	sb.append("sip:");
	sb.append(req.getLocalAddr());
	if(req.getLocalPort() > 0) {
	    sb.append(":");
	    sb.append(req.getLocalPort());
	}

	return getSipFactory().createAddress(sb.toString());
    }

    private SipServletResponse createResponse(SipServletRequest req, int code) {
	SipServletResponse res = req.createResponse(code);
	String chatID = req.getHeader("X-Chat-Id");
	if(chatID != null)
	    res.setHeader("X-Chat-Id", chatID);

	return res;
    }

    private void invalidateAppSession(SipServletResponse res) {
	SipSession session = res.getSession();
	SipApplicationSession appSession = session.getApplicationSession();
	appSession.invalidate();
    }
}


